import * as react_jsx_runtime from 'react/jsx-runtime';
import { R as RuntimeLoginOverridableOptions } from './types-Dmys-XR7.js';
import { Hex } from 'viem';
import { Chain, Cluster } from '@privy-io/js-sdk-core';
import '@coinbase/wallet-sdk';
import '@reown/appkit';
import '@solana/wallet-adapter-base';
import 'react';
import '@privy-io/public-api';
import '@base-org/account';
import '@solana/wallet-standard-features';
import '@wallet-standard/base';
import '@wallet-standard/features';
import '@metamask/eth-sig-util';
import '@solana/web3.js';
import 'eventemitter3';

type UserPillProps = {
    action?: {
        type: 'login';
        options?: RuntimeLoginOverridableOptions;
    } | {
        type: 'connectWallet';
        options?: {
            suggestedAddress?: string;
            description?: string;
        };
    };
    expanded?: boolean;
    label?: React.ReactNode;
    size?: number;
    ui?: {
        minimal?: boolean;
        background?: 'accent' | 'secondary';
    };
};
declare const UserPill: ({ expanded, action, label, size, ui: { minimal, background }, }: UserPillProps) => react_jsx_runtime.JSX.Element;

type EvmAsset = {
    chain: Chain;
    address: Hex;
    ticker: string;
    icon?: string;
};
type SolAsset = {
    cluster: Cluster;
    address: string;
    ticker: string;
    icon?: string;
};

type WalletsDialogProps = {
    networks?: {
        id: number;
    }[];
    assets?: {
        ethereum?: EvmAsset[];
        solana?: SolAsset[];
    };
};
declare const WalletsDialog: ({ networks, assets }: WalletsDialogProps) => react_jsx_runtime.JSX.Element;

export { UserPill, WalletsDialog };
